OpenJPH: ojph::dpx_in Class Reference

OpenJPH Open-source implementation of JPEG2000 Part-15

Loading...
Searching...
No Matches
ojph::dpx_in Class Reference

`#include <ojph_img_io.h>`

Inheritance diagram for ojph::dpx_in:

## Public Member Functions
| dpx_in ()
virtual | ~dpx_in ()
void | open (const char *filename)
virtual ui32 | read (const line_buf *line, ui32 comp_num)
void | close ()
size | get_size ()
ui32 | get_num_components ()
ui32 | get_bit_depth (ui32 comp_num)
bool | get_is_signed (ui32 comp_num)
point | get_comp_subsampling (ui32 comp_num)
Public Member Functions inherited from ojph::image_in_base
virtual | ~image_in_base ()

## Private Attributes
FILE * | file_handle
const char * | fname
void * | line_buffer
ui32 | width
ui32 | height
ui32 | num_comps
ui32 | cur_line
ui32 | bit_depth [4]
bool | is_signed [4]
point | subsampling [4]
ui32 | number_of_samples_per_line
ui16 * | line_buffer_16bit_samples
bool | is_byte_swapping_necessary
ui32 | offset_to_image_data_in_bytes
char | version [8]
ui32 | total_image_file_size_in_bytes
ui16 | image_orientation
ui16 | number_of_image_elements
ui32 | pixels_per_line
ui32 | lines_per_image_element
ui32 | data_sign_for_image_element_1
ui8 | descriptor_for_image_element_1
ui8 | transfer_characteristic_for_image_element_1
ui8 | colormetric_specification_for_image_element_1
ui8 | bitdepth_for_image_element_1
ui16 | packing_for_image_element_1
ui16 | encoding_for_image_element_1
ui32 | offset_to_data_for_image_element_1
size_t | number_of_32_bit_words_per_line

## Detailed Description

Definition at line 239 of file ojph_img_io.h.

## Constructor & Destructor Documentation

## ◆ dpx_in()

ojph::dpx_in::dpx_in | ( |  | ) |
| inline

Definition at line 242 of file ojph_img_io.h.

References bit_depth, cur_line, file_handle, fname, height, is_byte_swapping_necessary, is_signed, line_buffer, line_buffer_16bit_samples, num_comps, number_of_samples_per_line, subsampling, and width.

## ◆ ~dpx_in()

virtual ojph::dpx_in::~dpx_in | ( |  | ) |
| inlinevirtual

Definition at line 264 of file ojph_img_io.h.

References close(), line_buffer, and line_buffer_16bit_samples.

## Member Function Documentation

## ◆ close()

void ojph::dpx_in::close | ( |  | ) |
| inlinevirtual

Reimplemented from ojph::image_in_base.

Definition at line 275 of file ojph_img_io.h.

References file_handle, and fname.

Referenced by open(), read(), and ~dpx_in().

## ◆ get_bit_depth()

ui32 ojph::dpx_in::get_bit_depth | ( | ui32 | comp_num | ) |
| inline

Definition at line 285 of file ojph_img_io.h.

References bit_depth, file_handle, and num_comps.

Referenced by main().

## ◆ get_comp_subsampling()

point ojph::dpx_in::get_comp_subsampling | ( | ui32 | comp_num | ) |
| inline

Definition at line 293 of file ojph_img_io.h.

References file_handle, num_comps, and subsampling.

Referenced by main().

## ◆ get_is_signed()

bool ojph::dpx_in::get_is_signed | ( | ui32 | comp_num | ) |
| inline

Definition at line 289 of file ojph_img_io.h.

References file_handle, is_signed, and num_comps.

Referenced by main().

## ◆ get_num_components()

ui32 ojph::dpx_in::get_num_components | ( |  | ) |
| inline

Definition at line 284 of file ojph_img_io.h.

References file_handle, and num_comps.

Referenced by main(), and open().

## ◆ get_size()

size ojph::dpx_in::get_size | ( |  | ) |
| inline

Definition at line 283 of file ojph_img_io.h.

References file_handle, height, and width.

Referenced by main().

## ◆ open()

void ojph::dpx_in::open | ( | const char * | filename | ) |

Definition at line 1822 of file ojph_img_io.cpp.

References ojph::be2le(), bit_depth, bitdepth_for_image_element_1, close(), colormetric_specification_for_image_element_1, cur_line, data_sign_for_image_element_1, descriptor_for_image_element_1, encoding_for_image_element_1, file_handle, fname, get_num_components(), height, image_orientation, is_byte_swapping_necessary, is_signed, line_buffer, line_buffer_16bit_samples, lines_per_image_element, num_comps, number_of_32_bit_words_per_line, number_of_image_elements, number_of_samples_per_line, offset_to_data_for_image_element_1, offset_to_image_data_in_bytes, OJPH_ERROR, packing_for_image_element_1, pixels_per_line, subsampling, total_image_file_size_in_bytes, transfer_characteristic_for_image_element_1, version, and width.

Referenced by main().

## ◆ read()

ui32 ojph::dpx_in::read | ( | const line_buf * | line,
|  | ui32 | comp_num )
| virtual

Implements ojph::image_in_base.

Definition at line 2064 of file ojph_img_io.cpp.

References ojph::be2le(), bitdepth_for_image_element_1, close(), cur_line, descriptor_for_image_element_1, file_handle, fname, ojph::line_buf::i32, is_byte_swapping_necessary, line_buffer, line_buffer_16bit_samples, num_comps, number_of_32_bit_words_per_line, number_of_samples_per_line, OJPH_ERROR, packing_for_image_element_1, ojph::line_buf::size, and width.

## Member Data Documentation

## ◆ bit_depth

ui32 ojph::dpx_in::bit_depth[4]
| private

Definition at line 307 of file ojph_img_io.h.

Referenced by dpx_in(), get_bit_depth(), and open().

## ◆ bitdepth_for_image_element_1

ui8 ojph::dpx_in::bitdepth_for_image_element_1
| private

Definition at line 331 of file ojph_img_io.h.

Referenced by open(), and read().

## ◆ colormetric_specification_for_image_element_1

ui8 ojph::dpx_in::colormetric_specification_for_image_element_1
| private

Definition at line 330 of file ojph_img_io.h.

Referenced by open().

## ◆ cur_line

ui32 ojph::dpx_in::cur_line
| private

Definition at line 306 of file ojph_img_io.h.

Referenced by dpx_in(), open(), and read().

## ◆ data_sign_for_image_element_1

ui32 ojph::dpx_in::data_sign_for_image_element_1
| private

Definition at line 327 of file ojph_img_io.h.

Referenced by open().

## ◆ descriptor_for_image_element_1

ui8 ojph::dpx_in::descriptor_for_image_element_1
| private

Definition at line 328 of file ojph_img_io.h.

Referenced by open(), and read().

## ◆ encoding_for_image_element_1

ui16 ojph::dpx_in::encoding_for_image_element_1
| private

Definition at line 333 of file ojph_img_io.h.

Referenced by open().

## ◆ file_handle

FILE* ojph::dpx_in::file_handle
| private

Definition at line 299 of file ojph_img_io.h.

Referenced by close(), dpx_in(), get_bit_depth(), get_comp_subsampling(), get_is_signed(), get_num_components(), get_size(), open(), and read().

## ◆ fname

const char* ojph::dpx_in::fname
| private

Definition at line 301 of file ojph_img_io.h.

Referenced by close(), dpx_in(), open(), and read().

## ◆ height

ui32 ojph::dpx_in::height
| private

Definition at line 303 of file ojph_img_io.h.

Referenced by dpx_in(), get_size(), and open().

## ◆ image_orientation

ui16 ojph::dpx_in::image_orientation
| private

Definition at line 322 of file ojph_img_io.h.

Referenced by open().

## ◆ is_byte_swapping_necessary

bool ojph::dpx_in::is_byte_swapping_necessary
| private

Definition at line 316 of file ojph_img_io.h.

Referenced by dpx_in(), open(), and read().

## ◆ is_signed

bool ojph::dpx_in::is_signed[4]
| private

Definition at line 308 of file ojph_img_io.h.

Referenced by dpx_in(), get_is_signed(), and open().

## ◆ line_buffer

void* ojph::dpx_in::line_buffer
| private

Definition at line 302 of file ojph_img_io.h.

Referenced by dpx_in(), open(), read(), and ~dpx_in().

## ◆ line_buffer_16bit_samples

ui16* ojph::dpx_in::line_buffer_16bit_samples
| private

Definition at line 313 of file ojph_img_io.h.

Referenced by dpx_in(), open(), read(), and ~dpx_in().

## ◆ lines_per_image_element

ui32 ojph::dpx_in::lines_per_image_element
| private

Definition at line 325 of file ojph_img_io.h.

Referenced by open().

## ◆ num_comps

ui32 ojph::dpx_in::num_comps
| private

Definition at line 304 of file ojph_img_io.h.

Referenced by dpx_in(), get_bit_depth(), get_comp_subsampling(), get_is_signed(), get_num_components(), open(), and read().

## ◆ number_of_32_bit_words_per_line

size_t ojph::dpx_in::number_of_32_bit_words_per_line
| private

Definition at line 336 of file ojph_img_io.h.

Referenced by open(), and read().

## ◆ number_of_image_elements

ui16 ojph::dpx_in::number_of_image_elements
| private

Definition at line 323 of file ojph_img_io.h.

Referenced by open().

## ◆ number_of_samples_per_line

ui32 ojph::dpx_in::number_of_samples_per_line
| private

Definition at line 311 of file ojph_img_io.h.

Referenced by dpx_in(), open(), and read().

## ◆ offset_to_data_for_image_element_1

ui32 ojph::dpx_in::offset_to_data_for_image_element_1
| private

Definition at line 334 of file ojph_img_io.h.

Referenced by open().

## ◆ offset_to_image_data_in_bytes

ui32 ojph::dpx_in::offset_to_image_data_in_bytes
| private

Definition at line 318 of file ojph_img_io.h.

Referenced by open().

## ◆ packing_for_image_element_1

ui16 ojph::dpx_in::packing_for_image_element_1
| private

Definition at line 332 of file ojph_img_io.h.

Referenced by open(), and read().

## ◆ pixels_per_line

ui32 ojph::dpx_in::pixels_per_line
| private

Definition at line 324 of file ojph_img_io.h.

Referenced by open().

## ◆ subsampling

point ojph::dpx_in::subsampling[4]
| private

Definition at line 309 of file ojph_img_io.h.

Referenced by dpx_in(), get_comp_subsampling(), and open().

## ◆ total_image_file_size_in_bytes

ui32 ojph::dpx_in::total_image_file_size_in_bytes
| private

Definition at line 320 of file ojph_img_io.h.

Referenced by open().

## ◆ transfer_characteristic_for_image_element_1

ui8 ojph::dpx_in::transfer_characteristic_for_image_element_1
| private

Definition at line 329 of file ojph_img_io.h.

Referenced by open().

## ◆ version

char ojph::dpx_in::version[8]
| private

Definition at line 319 of file ojph_img_io.h.

Referenced by open().

## ◆ width

ui32 ojph::dpx_in::width
| private

Definition at line 303 of file ojph_img_io.h.

Referenced by dpx_in(), get_size(), open(), and read().

The documentation for this class was generated from the following files:

- /build/openjph/src/OpenJPH/src/apps/common/ojph_img_io.h
- /build/openjph/src/OpenJPH/src/apps/others/ojph_img_io.cpp